var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// build/index.ts
var build_exports = {};
__export(build_exports, {
  sampleFiles: () => sampleFiles
});
module.exports = __toCommonJS(build_exports);

// build/asset.ts
var import_fs = require("fs");
var import_promises = require("fs/promises");
var import_https = require("https");
var import_url = require("url");
var import_path = require("path");
var import_meta = {};
var ___filename = import_meta.url ? (0, import_url.fileURLToPath)(import_meta.url) : __filename;
var __dirname = (0, import_path.dirname)(___filename);
var allAssets = [];
var SampleFileAsset = class {
  /** The MIME type of the file */
  mime;
  /** The name of the file (without its extension) */
  name;
  /** The type of media (image, video, etc) */
  type;
  /** Filesize */
  bytes;
  /** File extension */
  extension;
  /** Github Raw link (used to download the file) */
  cdn;
  constructor(info) {
    Object.assign(this, info);
    allAssets.push(this);
  }
  /** Retrieves the absolute path to the assets' parent directory */
  get __dirname() {
    return (0, import_path.resolve)(__dirname + `/../local-assets/${this.type}/${this.extension}`);
  }
  /** Retrieves the absolute path to the asset
   * **WARNING**: The file will not be present if not yet downloaded. Utilize `path` instead of `__path`
   */
  get __path() {
    return `${this.__dirname}/${this.name}.${this.extension}`;
  }
  /** Checks if the file is downloaded */
  async isDownloaded() {
    const __path = this.__path;
    if (await (0, import_promises.access)(__path, 0).then((o) => true).catch((o) => false)) {
      const stats = await (0, import_promises.stat)(__path);
      if (stats.size == this.bytes) {
        return true;
      } else {
        await (0, import_promises.unlink)(__path);
      }
    }
    return false;
  }
  /** Downloads the file from the CDN
   * - Returns the path to the file
   */
  async download() {
    const __path = this.__path;
    if (await this.isDownloaded()) {
      return __path;
    }
    await (0, import_promises.mkdir)(this.__dirname, { recursive: true });
    const output = (0, import_fs.createWriteStream)(__path);
    const label = `- Downloading Sample File (${this.cdn})`;
    console.time(label);
    await new Promise(async (resolve2) => {
      const url = new URL(this.cdn);
      const req = (0, import_https.get)({
        port: 443,
        host: url.hostname,
        path: url.pathname,
        rejectUnauthorized: false,
        headers: {
          "Accept": "*/*",
          "Range": `bytes=0-`
        }
      }, async (res) => {
        res.pipe(output);
        res.on("end", () => {
          resolve2(true);
        });
      });
      req.on("error", (o) => console.log(o));
      req.end();
    });
    output.close();
    if (await this.isDownloaded()) {
      console.timeEnd(label);
      return __path;
    }
    throw new Error(`Failed to download asset from "${this.cdn}"`);
  }
  /** Retrieves the path to the file
   * - Automatically downloads the file if it is not yet downloaded
   */
  get path() {
    return new Promise(async (resolve2, reject) => {
      resolve2(await this.download());
    });
  }
  static filter(info) {
    if (!info) {
      return [...allAssets];
    }
    return allAssets.filter(typeof info === "function" ? info : (o) => {
      for (const key in info) {
        if (o[key] !== info[key]) {
          return false;
        }
      }
      return true;
    });
  }
};

// build/_assets.ts
var assets = {
  "video": {
    "mp4": {
      "bbb_short": new SampleFileAsset({ "mime": "video/mp4", "name": "bbb_short", "type": "video", "bytes": 788493, "extension": "mp4", "cdn": "https://raw.githubusercontent.com/cseitz/sample-files/main/assets/video/mp4/bbb_short.mp4" })
    }
  }
};

// build/index.ts
var sampleFiles = Object.assign(assets, {
  /** Filter assets by the specified search */
  filter: SampleFileAsset.filter
});
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  sampleFiles
});
//# sourceMappingURL=index.cjs.map